/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2011 SSAB Oxelosund AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 **/

#ifndef ge_attr_gtk_h
#define ge_attr_gtk_h

#include "ge_attr.h"
#include "ge_attrnav_gtk.h"
#include "cow_wow_gtk.h"

/* ge_attr.h -- Ge attribute editor */

/*! \file ge_attr_gtk.h
    \brief Contains the AttrGtk class. */
/*! \addtogroup Ge */
/*@{*/

//! Attribute editor.
/*! Displays grow attributes and dynamic attributes for an object or graph. */
class AttrGtk : public Attr {
  public:
    AttrGtk(
      GtkWidget                 *a_parent_wid,
      void			*a_parent_ctx,
      void 			*a_object,
      attr_sItem  		*itemlist,
      int			item_cnt);
    GtkWidget	*parent_wid;
    GtkWidget	*brow_widget;
    GtkWidget	*form_widget;
    GtkWidget	*toplevel;
    GtkWidget	*msg_label;
    GtkWidget	*cmd_prompt;
    GtkWidget	*cmd_input;
    GtkWidget	*cmd_scrolledinput;
    GtkWidget	*cmd_scrolledtextview;
    GtkWidget	*cmd_scrolled_ok;
    GtkWidget	*cmd_scrolled_ca;
    GtkTextBuffer *cmd_scrolled_buffer;
    GtkWidget	*pane;
    // int         recall_idx;
    // GeDyn 	*original_data;
    // static char	value_recall[30][160];
    // int		value_current_recall;
    static CoWowRecall 	value_recall;
    CoWowEntryGtk	*cmd_entry;

    void message( char severity, const char *message);
    void set_prompt( const char *prompt);
    void change_value();
    int reconfigure_attr();
    
    ~AttrGtk();
};


/*@}*/
#endif
