/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2011 SSAB Oxelosund AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 **/

#ifndef ge_subgraphs_gtk_h
#define ge_subgraphs_gtk_h

#include <gtk/gtk.h>

#ifndef ge_subgraphs_h
# include "ge_subgraphs.h"
#endif

/*! \file ge_subgraphs_gtk.h
    \brief Contains the SubGraphs class and related classes. */
/*! \addtogroup Ge */
/*@{*/

//! Display loaded subgraphs.
class SubGraphsGtk : public SubGraphs {
  public:
    SubGraphsGtk(
	void 		*xn_parent_ctx,
	GtkWidget	*xn_parent_wid,
	const char     	*xn_name,
	void 		*grow_ctx,
	GtkWidget 	**w,
	pwr_tStatus 	*status);

    GtkWidget		*parent_wid;
    GtkWidget		*subgraphs_form;
    GtkWidget		*toplevel;
    GtkWidget		*brow_widget;
    GtkWidget		*form_widget;
    gint		trace_timerid;

    void trace_start();
    Attr *new_attr( void *object, attr_sItem *items, int num);
    static void trace_scan( SubGraphsGtk *subgraphs);
    ~SubGraphsGtk();
};


/*@}*/
#endif
